// Function/Procedure Prototype Table  -  Last Update: 04-20-93 @ 03:08:52pm
// 
// Return Value         Function/Arguments
//   
// Void                 PROCEDURE ClockDisp( aClock )
// Void                 PROCEDURE ClockProc( aMsg )
// aWind                FUNCTION ClockNew( nRow, nCol, nFormat, cColor )

#include "msg.ch"
#include "wind.ch"
#include "inkey.ch"
#include "clock.ch"
#include "misc.ch"

STATIC saClock := {}
STATIC shClock := 0

FUNCTION ClockNew( nRow, nCol, nFormat, cColor )

	LOCAL aClock := ARRAY( CL_SIZE )
	LOCAL aWind

	aClock[ CL_ROW ]     := nRow
	aClock[ CL_COL ]     := nCol
	aClock[ CL_COLOR ]   := cColor
	aClock[ CL_FORMAT ]  := nFormat
	aClock[ CL_HANDLE ]  := ++shClock

	aWind := wNew( "", nRow, nCol, nRow, nCol + 7, { |aMsg| ClockProc( aMsg ) }, aClock )

	aClock[ CL_WINDOW ] := aWind

	// assign a timer request
	SetTimer( aWind, 0 )

	AADD( saClock, aClock )

RETURN( aWind )



PROCEDURE ClockDisp( aWind )

	LOCAL nRow   := ROW()
	LOCAL nCol   := COL()
	LOCAL aClock := aWind[ W_CARGO ]

	DEVPOS( aClock[ CL_ROW ], aClock[ CL_COL ] )
	DEVOUT( TIME(), aClock[ CL_COLOR ] )
	DEVPOS( nRow, nCol )

RETURN


PROCEDURE ClockProc( aMsg )

	LOCAL aWind  := aMsg[ M_WINDOW ]
	LOCAL msg    := aMsg[ M_MSG ]
	LOCAL nParm  := aMsg[ M_PARM ]
	LOCAL aNext

	DO CASE
	CASE ( msg == WM_TIMER )
		ClockDisp( aWind )

	CASE ( msg == WM_PAINT )
		ClockDisp( aWind )

	CASE ( msg == WM_SETFOCUS )
		// try to give focus to next window in list
		IF ( ! ( ( aNext := wNext() ) == aWind ) )
			SetFocus( aNext )
		ELSE
			// the clock is the only thing that's left -- kill it
			wKill( aWind )
		ENDIF

	CASE ( msg == WM_DESTROY )
		wKill( aWind )

	ENDCASE

	aWind[ W_LASTTIME ] := seconds()

RETURN
// EOF: CLOCK.PRG
