//  Program Ŀ
//  Application  : Event Driven Programming Sample                          
//  Description  : Sample                                                   
//  File Name    : EVENT1.PRG                                               
//  Author       : Erik Wynn                                                
//  Date created : 02-02-93              Date updated: 02-02-93            
//  Time created : 07:50:37am            Time updated: 07:50:37am          
//  Make File    : EVENT1.RMK                                               
//  Exec File    : EVENT1.EXE                                               
//  Copyright    : (c) 1993 by Wynn Systems Development Group, Ltd.         
// 


#include "setcurs.ch"
#include "inkey.ch"
#include "misc.ch"

#define W_TITLE 1
#define W_T     2
#define W_L     3
#define W_B     4
#define W_R     5
#define W_ROW   6
#define W_COL   7
#define W_SIZE  7

static slSecond := FALSE
static slThird  := FALSE

PROCEDURE Event1()

	LOCAL cDosScreen := SAVESCREEN( 0, 0, MAXROW(), MAXCOL() )
	LOCAL nRow       := ROW()
	LOCAL nCol       := COL()
	LOCAL aWind      := ARRAY( W_SIZE )

	aWind[ W_TITLE ] := "Window 1"
	aWind[ W_T ]     := 5
	aWind[ W_L ]     := 5
	aWind[ W_B ]     := 15
	aWind[ W_R ]     := 55
	aWind[ W_ROW ]   := 6
	aWind[ W_COL ]   := 6

	SETBLINK( FALSE )
	SETCOLOR( "W+/N*" )
	SCROLL()

	@ 0, 0 SAY PADC( "Event-Driven Programming Sample 1", MAXCOL() + 1 ) COLOR "N/W"

	SETCOLOR( "N/W" )
	SCROLL( aWind[ W_T ], aWind[ W_L ], aWind[ W_B ], aWind[ W_R ] )
	@ aWind[ W_T ], aWind[ W_L ] SAY PADC( aWind[ W_TITLE ], aWind[ W_R ] - aWind[ W_L ] + 1 ) COLOR "N/GR*"

	MyProc( aWind )

	SETBLINK( TRUE )
	RESTSCREEN( 0, 0, MAXROW(), MAXCOL(), cDosScreen )
	DEVPOS( nRow, nCol )

RETURN

STATIC PROCEDURE MyProc( aWind )

	LOCAL nKey

	// loop
	WHILE ( ( nKey := INKEY( 0 ) ) != K_ALT_F4 )

		DO CASE
		CASE ( nKey == K_F1 )
			// call up a another window
			IF ( slSecond )
				IF ! slThird
					ThirdWindow()
				ENDIF
			ELSE
				SecondWindow()
			ENDIF

		CASE ( nKey == K_ENTER )
			// advance to the next line
			LineAdvance( aWind )

		CASE ( nKey == K_BS )
			// back up by one, if possible
			IF ! ( ( aWind[ W_ROW ] == aWind[ W_T ] + 1 ) .and. ( aWind[ W_COL ] == aWind[ W_L ] + 1 ) )
				csrRewind( aWind )
				wPrintChar( aWind, " " )
				wPrintChar( aWind, "" )
			ENDIF

		CASE ( nKey > 31 )
			// printable character -- print it
			wPrintText( aWind, nKey )

		OTHERWISE
			TONE( 400, 2 )

		ENDCASE

	END

RETURN


PROCEDURE wPrintText( aWind, nChar )

	wPrintChar( aWind, CHR( nChar ) )
	CsrAdvance( aWind )

RETURN


PROCEDURE wPrintChar( aWind, cChar )

	@ aWind[ W_ROW ], aWind[ W_COL ] SAY cChar

RETURN


PROCEDURE CsrAdvance( aWind )

	IF ( ++aWind[ W_COL ] == aWind[ W_R ] )
		aWind[ W_COL ] := aWind[ W_L ] + 1
		LineAdvance( aWind )
	ELSE
		// reposition cursor
		DEVPOS( aWind[ W_ROW ], aWind[ W_COL ] )
	ENDIF

RETURN


PROCEDURE LineAdvance( aWind )

	IF ( aWind[ W_ROW ] == aWind[ W_B ] - 1 )
		SCROLL( aWind[ W_T ] + 1, aWind[ W_L ] + 1, aWind[ W_B ] - 1, aWind[ W_R ] - 1, 1 )
	ELSE
		aWind[ W_ROW ]++
	ENDIF

	aWind[ W_COL ] := aWind[ W_L ] + 1

	// reposition cursor
	DEVPOS( aWind[ W_ROW ], aWind[ W_COL ] )

RETURN

PROCEDURE CsrRewind( aWind )

	aWind[ W_COL ]--
	IF aWind[ W_COL ] == aWind[ W_L ]
		aWind[ W_ROW ]--
		aWind[ W_COL ] := aWind[ W_R ] - 1
	ENDIF

	// reposition cursor
	DEVPOS( aWind[ W_ROW ], aWind[ W_COL ] )

RETURN


PROCEDURE SecondWindow()

	LOCAL aWind := ARRAY( W_SIZE )
	LOCAL cOldScreen

	aWind[ W_TITLE ] := "Window 2"
	aWind[ W_T ]     := 5
	aWind[ W_L ]     := 60
	aWind[ W_B ]     := 15
	aWind[ W_R ]     := 75
	aWind[ W_ROW ]   := 6
	aWind[ W_COL ]   := 61

	cOldScreen := SAVESCREEN( aWind[ W_T ], aWind[ W_L ], aWind[ W_B ], aWind[ W_R ] )
	SETCOLOR( "N/W" )
	SCROLL( aWind[ W_T ], aWind[ W_L ], aWind[ W_B ], aWind[ W_R ] )
	@ aWind[ W_T ], aWind[ W_L ] SAY PADC( aWind[ W_TITLE ], aWind[ W_R ] - aWind[ W_L ] + 1 ) COLOR "N/GR*"
	@ aWind[ W_T ] + 1, aWind[ W_L ] + 1 SAY ""

	slSecond := TRUE
	MyProc( aWind )
	slSecond := FALSE

	RESTSCREEN( aWind[ W_T ], aWind[ W_L ], aWind[ W_B ], aWind[ W_R ], cOldScreen )

RETURN


PROCEDURE ThirdWindow()

	LOCAL aWind := ARRAY( W_SIZE )
	LOCAL cOldScreen

	aWind[ W_TITLE ] := "Window 3"
	aWind[ W_T ]     := 18
	aWind[ W_L ]     := 5
	aWind[ W_B ]     := 23
	aWind[ W_R ]     := 75
	aWind[ W_ROW ]   := 19
	aWind[ W_COL ]   := 6

	cOldScreen := SAVESCREEN( aWind[ W_T ], aWind[ W_L ], aWind[ W_B ], aWind[ W_R ] )
	SETCOLOR( "N/W" )
	SCROLL( aWind[ W_T ], aWind[ W_L ], aWind[ W_B ], aWind[ W_R ] )
	@ aWind[ W_T ], aWind[ W_L ] SAY PADC( aWind[ W_TITLE ], aWind[ W_R ] - aWind[ W_L ] + 1 ) COLOR "N/GR*"
	@ aWind[ W_T ] + 1, aWind[ W_L ] + 1 SAY ""

	slThird := TRUE
	MyProc( aWind )
	slThird := FALSE

	RESTSCREEN( aWind[ W_T ], aWind[ W_L ], aWind[ W_B ], aWind[ W_R ], cOldScreen )

RETURN


