//  Program Ŀ
//  Application  : Event Driven Programming Sample                          
//  Description  : Sample                                                   
//  File Name    : EVENT2.PRG                                               
//  Author       : Erik Wynn                                                
//  Date created : 02-02-93              Date updated: 02-02-93            
//  Time created : 07:50:37am            Time updated: 07:50:37am          
//  Make File    : EVENT2.RMK                                               
//  Exec File    : EVENT2.EXE                                               
//  Copyright    : (c) 1993 by Wynn Systems Development Group, Ltd.         
// 

// Function/Procedure Prototype Table  -  Last Update: 02-02-93 @ 01:55:46pm
// 
// Return Value         Function/Arguments
//   
// Void                 PROCEDURE DispatchMessage( aMsg )
// Void                 PROCEDURE Event2()
// aMsg                 FUNCTION GetMessage()


#include "setcurs.ch"
#include "inkey.ch"
#include "wind.ch"
#include "msg.ch"
#include "misc.ch"

PROCEDURE Event2()

	LOCAL w1, w2, w3
	LOCAL cDosScreen := SAVESCREEN( 0, 0, MAXROW(), MAXCOL() )
	LOCAL nRow       := ROW()
	LOCAL nCol       := COL()
	LOCAL nSavCrs    := SETCURSOR( SC_NONE )
	LOCAL aMsg

	SETBLINK( FALSE )
	SETCOLOR( "W+/N*" )
	SCROLL()

	@ 0, 0 SAY PADC( "Event-Driven Programming Sample 2", MAXCOL() + 1 ) COLOR "N/W"

	// create a few window pseudo-objects
	w1 := wNew( "Window 1", 5, 5, 15, 55,  { |aMsg| TextProc( aMsg ) } )
	w2 := wNew( "Window 2", 5, 60, 15, 75, { |aMsg| TextProc( aMsg ) } )
	w3 := wNew( "Window 3", 18, 5, 23, 75, { |aMsg| TextProc( aMsg ) } )

	// give focus to the window
	SetFocus( w1 )

	// display the window
	wDisp( w1 )
	wDisp( w2 )
	wDisp( w3 )

	// main event loop
	WHILE ( ( aMsg := GetMessage() )[ M_MSG ] != WM_EXIT )

		IF aMsg[ M_MSG ] != WM_IDLE
			DispatchMessage( aMsg )
		ENDIF

	END

	SETCURSOR( nSavCrs )
	SETBLINK( TRUE )
	RESTSCREEN( 0, 0, MAXROW(), MAXCOL(), cDosScreen )
	DEVPOS( nRow, nCol )

RETURN


FUNCTION GetMessage()

	LOCAL aMsg := ARRAY( M_ASIZE )
	LOCAL nKey := INKEY()

	DO CASE
	CASE nKey == 0
		aMsg[ M_MSG ] := WM_IDLE

	CASE ( nKey == K_ALT_F4 )
		aMsg[ M_MSG ] := WM_EXIT

	CASE ( nKey == K_TAB )
		SetFocus( wNext() )
		aMsg[ M_MSG ] := WM_IDLE

	CASE ( nKey == K_SH_TAB )
		SetFocus( wPrev() )
		aMsg[ M_MSG ] := WM_IDLE

	OTHERWISE
		aMsg[ M_WINDOW ] := wCurrent()
		aMsg[ M_MSG ]    := WM_CHAR
		aMsg[ M_PARM ]   := nKey

	ENDCASE

RETURN( aMsg )


PROCEDURE DispatchMessage( aMsg )

	IF ( aMsg[ M_MSG ] != WM_IDLE )
		EVAL( aMsg[ M_WINDOW ][ W_PROC ], aMsg )
	ENDIF

RETURN
