//  Program Ŀ
//  Application  : Event Driven Programming Sample                          
//  Description  : Sample                                                   
//  File Name    : EVENT3.PRG                                               
//  Author       : Erik Wynn                                                
//  Date created : 02-02-93              Date updated: 02-02-93            
//  Time created : 07:50:37am            Time updated: 07:50:37am          
//  Make File    : EVENT3.RMK                                               
//  Exec File    : EVENT3.EXE                                               
//  Copyright    : (c) 1993 by Wynn Systems Development Group, Ltd.         
// 

// Function/Procedure Prototype Table  -  Last Update: 02-02-93 @ 01:56:01pm
// 
// Return Value         Function/Arguments
//   
// Void                 PROCEDURE DispatchMessage( aMsg )
// Void                 PROCEDURE Event3()
// aMsg                 FUNCTION GetMessage( )


#include "setcurs.ch"
#include "inkey.ch"
#include "wind.ch"
#include "msg.ch"
#include "misc.ch"

PROCEDURE Event3()

	LOCAL w1, w2, w3
	LOCAL cDosScreen := SAVESCREEN( 0, 0, maxRow(), maxCol() )
	LOCAL nRow       := ROW()
	LOCAL nCol       := COL()
	LOCAL nSavCrs    := SETCURSOR( SC_NONE )
	LOCAL aMsg

	SETBLINK( FALSE )
	SETCOLOR( "W+/N*" )
	SCROLL()

	@ 0, 0 SAY PADC( "Event-Driven Programming Sample 3 - Watch the Clock", MAXCOL() + 1 ) COLOR "N/W"

	// create a few "windows"
	w1 := wNew( "Window 1",  5,  5, 10, 30, { |aMsg| BasicProc( aMsg ) } )
	w2 := wNew( "Window 2", 12,  5, 20, 40, { |aMsg| TextProc( aMsg ) } )
	w3 := wNew( "Window 3",  5, 45, 22, 75, { |aMsg| WierdProc( aMsg ) } )

	// give focus to the first window
	SetFocus( w1 )

	// display the "windows"
	wDisp( w1 )
	wDisp( w2 )
	wDisp( w3 )

	// the main event loop
	WHILE ( ( aMsg := GetMessage() )[ M_MSG ] != WM_EXIT )

		DispatchMessage( aMsg )

	END

	SETCURSOR( nSavCrs )
	SETBLINK( TRUE )
	RESTSCREEN( 0, 0, MAXROW(), MAXCOL(), cDosScreen )
	DEVPOS( nRow, nCol )

RETURN


FUNCTION GetMessage( )

	LOCAL aMsg := ARRAY( M_ASIZE )
	LOCAL nKey := INKEY()
	LOCAL nRow := ROW()
	LOCAL nCol := COL()

	@ 0, 72 SAY TIME() COLOR "W/R"
	DEVPOS( nRow, nCol )

	DO CASE
	CASE nKey == 0
		aMsg[ M_MSG ] := WM_IDLE

	CASE ( nKey == K_ALT_F4 )
		aMsg[ M_MSG ] := WM_EXIT

	CASE ( nKey == K_TAB )
		SetFocus( wNext() )
		aMsg[ M_MSG ] := WM_IDLE

	CASE ( nKey == K_SH_TAB )
		SetFocus( wPrev() )
		aMsg[ M_MSG ] := WM_IDLE

	OTHERWISE
		aMsg[ M_WINDOW ] := wCurrent()
		aMsg[ M_MSG ]    := WM_CHAR
		aMsg[ M_PARM ]   := nKey

	ENDCASE

RETURN( aMsg )


PROCEDURE DispatchMessage( aMsg )

	IF ( aMsg[ M_MSG ] != WM_IDLE )
		EVAL( aMsg[ M_WINDOW ][ W_PROC ], aMsg )
	ENDIF

RETURN
