//  Program Ŀ
//  Application  : Event Driven Programming Sample                          
//  Description  : Sample                                                   
//  File Name    : EVENT9.PRG                                               
//  Author       : Erik Wynn                                                
//  Date created : 02-02-93              Date updated: 02-02-93            
//  Time created : 07:50:37am            Time updated: 07:50:37am          
//  Make File    : EVENT9.RMK                                               
//  Exec File    : EVENT9.EXE                                               
//  Copyright    : (c) 1993 by Wynn Systems Development Group, Ltd.         
// 

// Function/Procedure Prototype Table  -  Last Update: 04-21-93 @ 01:06:17pm
// 
// Return Value         Function/Arguments
//   
// Void                 PROCEDURE DispatchMessage( aMsg )
// Void                 PROCEDURE Event9()
// Void                 PROCEDURE yield()
// aMsg                 FUNCTION GetMessage()


#include "setcurs.ch"
#include "inkey.ch"
#include "wind.ch"
#include "msg.ch"
#include "misc.ch"
#include "set.ch"

PROCEDURE Event9()

	LOCAL fr1
	LOCAL w1
	LOCAL w2
	LOCAL cl1
	LOCAL cDosScreen := SAVESCREEN( 0, 0, MAXROW(), MAXCOL() )
	LOCAL nRow       := ROW()
	LOCAL nCol       := COL()
	LOCAL nSavCrs    := SETCURSOR( SC_NONE )
	LOCAL aMsg

	SET( _SET_SCOREBOARD, FALSE )                  // "Ins" is stupid
	SETBLINK( FALSE )
	SETCOLOR( "W+/N*" )
	SCROLL()

	@ 0, 0 SAY PADC( "Event-Driven Programming Sample 9 - Evil ReadModal()", MAXCOL() + 1 ) COLOR "N/W"

	// create a few "windows"
	cl1 := ClockNew( 0, 72, NIL, "R/W" )
	fr1 := FractNew( "Fractal 2", 12, 2, 23, 30, ;
			{ "B/W", "G/W", "R+/W", "BG/W", "RB/W", ;
			"BG+/W", "GR+/W", "R/W", "W+/W", "G+/W", "W/W" } )

	fr1[ W_AREA_CLR ] := "W/B"                     // just to be different

	w1 := wNew( "Window 1",  4,  2, 10, 20, { |aMsg| TextProc( aMsg ) } )
	w2 := wDialogNew( "Santa Claus - Dialog Window", 4, 32, 20, 77, { |aMsg| SantaProc( aMsg ) } )

	wLimit( fr1, 1 )    // don't step
	wLimit( w1,  1 )    // on the clock
	wLimit( w2,  1 )

	// give focus to the first window
	SetFocus( w1 )

	// display the pseudo-objects
	wDisp( w1 )
	wDisp( w2 )
	FractDisp( fr1 )
	ClockDisp( cl1 )

	// the main event loop
	WHILE ( ( aMsg := getMessage() )[ M_MSG ] != WM_EXIT )

		DispatchMessage( aMsg )

	END

	SETCURSOR( nSavCrs )
	SETBLINK( TRUE )
	RESTSCREEN( 0, 0, MAXROW(), MAXCOL(), cDosScreen )
	DEVPOS( nRow, nCol )

RETURN


FUNCTION GetMessage()

	LOCAL aMsg  := ARRAY( M_ASIZE )
	LOCAL nKey  := INKEY()
	LOCAL aWind := wFirst()

	IF aWind == NIL .and. wLast() == NIL
		// no windows left -- exit system
		aMsg[ M_MSG ] := WM_EXIT

	ELSE

		// assign the time of the message
		aMsg[ M_TIME ] := seconds()

		// process window list for timer messages
		WHILE ( aWind != NIL )
			IF ( ( aWind[ W_TIMER ] != NIL ) .and. ( seconds() - aWind[ W_LASTTIME ] >= aWind[ W_TIMER ] ) )
				aMsg[ M_MSG ] := WM_TIMER
				aMsg[ M_WINDOW ] := aWind
				DispatchMessage( aMsg )
			ENDIF
			aWind := aWind[ W_NEXT ]
		END

		DO CASE
		CASE ( nKey == 0 )
			aMsg[ M_MSG ] := WM_IDLE

		CASE ( nKey == K_ALT_F4 )
			aMsg[ M_MSG ] := WM_DESTROY
			aMsg[ M_WINDOW ] := wCurrent()

		CASE ( nKey == K_TAB )
			SetFocus( wNext() )
			aMsg[ M_MSG ] := WM_IDLE

		CASE ( nKey == K_SH_TAB )
			SetFocus( wPrev() )
			aMsg[ M_MSG ] := WM_IDLE

		CASE ( ( nKey == K_CTRL_UP ) .or. ;
				( nKey == K_CTRL_DOWN ) .or. ;
				( nKey == K_CTRL_LEFT ) .or. ;
				( nKey == K_CTRL_RIGHT ) )

			aMsg[ M_MSG ]    := WM_MOVE
			aMsg[ M_WINDOW ] := wCurrent()
			aMsg[ M_PARM ]   := nKey

		OTHERWISE
			aMsg[ M_WINDOW ] := wCurrent()
			aMsg[ M_MSG ]    := WM_CHAR
			aMsg[ M_PARM ]   := nKey

		ENDCASE

	ENDIF

RETURN( aMsg )


PROCEDURE DispatchMessage( aMsg )

	IF ( aMsg[ M_MSG ] != WM_IDLE )
		EVAL( aMsg[ M_WINDOW ][ W_PROC ], aMsg )
	ENDIF

RETURN


PROCEDURE yield()

 	// check event queue for pending events
	DispatchMessage( getMessage() )

RETURN

