// Program 
// Application  : Event Driven Programming Sample
// Purpose      : Demonstrate yeild() Function
// File Name    : INDEX2.PRG
// Section      :
// Category     :
// Description  : Demonstrate yield() Function
// Author       : Erik Wynn
// Copyright    : (c) 1993 by Wynn Systems Development Group, Ltd.
// Date created : 04-21-93              Date updated: 04-21-93
// Time created : 09:41:18am            Time updated: 09:41:18am
//


#include "inkey.ch"
#include "msg.ch"
#include "wind.ch"
#include "misc.ch"

static slCreating := FALSE

PROCEDURE IndexProc( aMsg )

	LOCAL aWind   := aMsg[ M_WINDOW ]
	LOCAL msg     := aMsg[ M_MSG ]
	LOCAL nParm   := aMsg[ M_PARM ]

	DO CASE
	CASE ( msg == WM_SETFOCUS )
		wGetFocus( aWind )

	CASE ( msg == WM_KILLFOCUS )
		wKillFocus( aWind )

	CASE ( msg == WM_MOVE )
		wMove( aWind, nParm )

	CASE ( msg == WM_HIDE )
		wHide( aWind )

	CASE ( msg == WM_PAINT )
		wDisp( aWind )

	CASE ( msg == WM_CREATE )
		HelloMsg( aWind )

	CASE ( ( msg == WM_DESTROY ) .and. ( ! slCreating ) )
		wKill( aWind )

	CASE ( msg == WM_CHAR )
		IF ( ( nParm == K_ENTER ) .and. ( ! slCreating ) )
			//
			// begin modal process of creating index
			MakeIndex( aWind )
		ENDIF

	ENDCASE

RETURN


STATIC PROCEDURE HelloMsg( aWind )

	wSay( aWind, 1, 0, " Select this window and   " )
	wSay( aWind, 2, 0, " press the <Enter> key to " )
	wSay( aWind, 3, 0, " create the SANTA database" )
	wSay( aWind, 4, 0, " and index files.         " )

RETURN


STATIC PROCEDURE MakeIndex( aWind )

	slCreating := TRUE

	wSay( aWind, 6, 0, " Creating Database..." )
	MakeSanta( TRUE, aWind )                              // yield to messages
	wSay( aWind, 6, 0, " Database created.      " )

	USE SANTA ALIAS SANTA NEW

	wSay( aWind, 8, 0, " Creating Index...   " )
	SANTA->( ;
		DBCREATEIND( ;
				"SANTA.NTX", ;
				"SANTA->LAST_NAME + SANTA->FIRST_NAME", ;
				{ || SantaIndex( aWind ) } ;
			) ;
		)

	wSay( aWind, 8, 0, " Index Created.      " )

	slCreating := FALSE

	SANTA->( DBCLOSEAREA() )

RETURN


FUNCTION SantaIndex( aWind )

	STATIC nCount := 0
	wSay( aWind, 8, 22, Twiddle() )

	// check the event queue for any other events which may require attention
	if ( ++nCount % 10 ) == 0
		yield()
	endif

	// return actual index key

RETURN( SANTA->LAST_NAME + SANTA->FIRST_NAME )

