#include "inkey.ch"
#include "msg.ch"
#include "wind.ch"
#include "misc.ch"

#define MSG_WINDOW 1
#define MSG_PARENT 2

#define MSG_ASIZE  2

FUNCTION MessageNew( cTitle, nT, nL, nB, nR, wParent )

	LOCAL aMsgWind := ARRAY( MSG_ASIZE )
	LOCAL aWind

	aMsgWind[ MSG_WINDOW ] := wNew( cTitle, nT, nL, nB, nR, { |aMsg| MsgProc( aMsg ) }, aMsgWind )
	aMsgWind[ MSG_PARENT ] := wParent

	// special colors for a message window
	aWind := aMsgWind[ MSG_WINDOW ]
	aWind[ W_AREA_CLR ] := "W/BG"
	aWind[ W_TEXT_CLR ] := "B/BG"

	// limit movement to inside parent window client area
	wLimit( aWind, wParent[ W_T ] + 1, wParent[ W_L ], wParent[ W_B ], wParent[ W_R ] )

RETURN( aWind )


PROCEDURE MsgProc( aMsg )

	LOCAL aWind   := aMsg[ M_WINDOW ]
	LOCAL msg     := aMsg[ M_MSG ]
	LOCAL nParm   := aMsg[ M_PARM ]
	LOCAL aParent

	DO CASE
	CASE ( msg == WM_SETFOCUS )
		wGetFocus( aWind )

	CASE ( ( msg == WM_KILLFOCUS ) .or. ;
			( msg == WM_DESTROY )	.or. ;
			( msg == WM_CHAR ) )

		// kill window and restore focus to parent window
		aParent := aWind[ W_CARGO ][ MSG_PARENT ]
		wKill( aWind )
		SetFocus( aParent )

	CASE ( msg == WM_MOVE )
		wMove( aWind, nParm )

	CASE ( msg == WM_HIDE )
		wHide( aWind )

	CASE ( msg == WM_PAINT )
		wDisp( aWind )

	ENDCASE

RETURN

