#include "misc.ch"

// Procedure Ŀ
//         Name: MakeSANTA()                                                
//  Description:                                                            
//       Author: DBFMake, version 1.1                                       
// Date created: 04/22/93                                                   
// Time created: 16:31:19                                                   
//    Copyright: Wynn Systems Development Group, Ltd                        
//Ĵ
//   Parameters: None                                                       
//

PROCEDURE MakeSANTA( lYield, aWind )

	LOCAL aStru := {}

	AADD( aStru, { "FIRST_NAME", "C", 10, 0 } )
	AADD( aStru, { "LAST_NAME", "C", 20, 0 } )
	AADD( aStru, { "ADDRESS", "C", 30, 0 } )
	AADD( aStru, { "HOME_PHONE", "C", 10, 0 } )
	AADD( aStru, { "WORK_PHONE", "C", 10, 0 } )
	AADD( aStru, { "CITY", "C", 20, 0 } )
	AADD( aStru, { "STATE", "C", 20, 0 } )
	AADD( aStru, { "COUNTRY", "C", 20, 0 } )
	AADD( aStru, { "ZIP", "C", 10, 0 } )
	AADD( aStru, { "GOOD_BAD", "L", 1, 0 } )

	DBCREATE( "SANTA.DBF", aStru )

	Populate( lYield, aWind )

RETURN


// Procedure Ŀ
//         Name: Populate()                                                 
//  Description: Add records to the SANTA file                              
//       Author: DBFMake, version 1.1                                       
// Date created: 04/22/93                                                   
// Time created: 16:31:19                                                   
//    Copyright: Wynn Systems Development Group, Ltd                        
//Ĵ
//   Parameters: lYield, aWind                                              
//

STATIC PROCEDURE Populate( lYield, aWind )

	// Thanks to SDI for the populate idea

#define MAX_RECORDS 500

	LOCAL i
	LOCAL nAreaCode
	LOCAL nExchange

	LOCAL aFirst := { ;
		"Arnold", "Bert", "Charles", "Don", "Erik", "Fred", "Greg", "Hans", ;
		"Jeff", "John", "Kevin", "Mike", "Peter", "Steve", "Trevor", "William", ;
		"Amy", "Betty", "Cynthia", "Donna", "Enid", "Francis", "Ingrid", ;
		"Janet", "Jennifer", "Karen", "Lucy", "Marcie", "Nancy", "Rose", ;
		"Stephanie", "Victoria" }                    // 32

	LOCAL aLast := { ;
		"Arnold", "Baker", "Chan", "Campbell", "Dijkstra", "Evans", "Faulkner", ;
		"Gagnon", "Hart", "Ibrahim", "Johnston", "Jackson", "Kingsbury", ;
		"Lemieux", "McConnell", "MacDonald", "Nicholson", "Nakamichi", ;
		"O'Conner", "Perez", "Raymond", "Robertson", "Singh", "Smith", ;
		"Thompson", "Vandenberg", "Wynn", "Xenon", "Yee", "Zappa" }  // 30

	LOCAL aDirs    := { " ", " N. ", " S. ", " E. ", " W. " }  // 5
	LOCAL aLabels  := { "St.", "Rd.", "Ln.", "Ave.", "Blvd.", "Dr." }  // 6
	LOCAL aStreets := { "First ", "Second ", "Third ", "Fourth ", ;
		"Fifth ", "Sixth ", "Seventh ", "Eighth ", "Ninth ", ;
		"Tenth ", "Oak ", "Elm ", "Maple ", "Pine ", "Aspen ", ;
		"Willow ", "Crabapple ", "Birch ", ;
		"Main ", "Metcalf ", "Robertson ", "Eagleson ", "Terry Fox ", ;
		"Katimivik ", "Sussex ", "Wellington ", "Delhousie " }  // 27

	LOCAL aStates := { "Alabama", "Alaska", "Arizona", "Arkansas", ;
		"California", "Colorado", "Connecticut", "Delaware", ;
		"Florida", "Georgia", "Hawaii", "Idaho", ;
		"Illinois", "Indiana", "Iowa", "Kansas", ;
		"Kentucky", "Louisiana", "Maine", "Maryland", ;
		"Massachusetts", "Michigan", "Minnesota", "Mississippi", ;
		"Missouri", "Montanna", "Nebraska", "Nevada", ;
		"New Hampshire", "New Jersey", "New Mexico", "New York", ;
		"North Carolina", "North Dakota", "Ohio", "Oklahoma", ;
		"Oregon", "Pennsylvania", "Rhode Island", "South Carolina", ;
		"South Dakota", "Tennessee", "Texas", "Utah", ;
		"Vermont", "Virginia", "Washington", "West Virginia", ;
		"Wisconsin", "Wyoming" }                     // 50

	LOCAL aCities := { "Kanata", "Misquito Creek", "St. Jovite", ;
		"Riverdale", "Sandy Hill", "Sidney", "Liverpool", ;
		"Hartford", "Norfolk", "New York", "London", ;
		"Paris", "Jefferson", "Rockville", "Ottawa", ;
		"Chicago", "Los Angeles", "San Angelo", "Dallas", ;
		"Austin", "San Fransisco", "Reading", "Ben Avon", ;
		"Saskatoon", "Chapel Hill", "Carp", "Liberty", ;
		"Madison", "Richland", "Rochester", "Elkart", ;
		"Minot" }                                    // 32

	USE SANTA ALIAS SANTA NEW

	FOR i := 1 TO MAX_RECORDS

		// entertain the user...
		wSay( aWind, 6, 22, Twiddle() )

		// add a blank record
		SANTA->( dbAppend() )

		// replace the data
		nAreaCode := ;
			( NewNumber( 2, 9 ) * 100 + ;
			NewNumber( 0, 1 ) * 10 + ;
			NewNumber( 2, 9 ) ) *	10000000

		nExchange := ;
			( NewNumber( 2, 9 ) * 100 + ;
			NewNumber( 2, 9 ) * 10 + ;
			NewNumber( 0, 9 ) ) *	10000


		SANTA->FIRST_NAME := aFirst[ NewNumber( 1, 32 ) ]
		SANTA->LAST_NAME  := aLast[ NewNumber( 1, 30 ) ]
		SANTA->ADDRESS    := LTRIM( STR( NewNumber( 100, 20000 ) ) ) + ;
			aDirs[ NewNumber( 1, 5 ) ] + ;
			aStreets[ NewNumber( 1, 27 ) ] + ;
			aLabels[ NewNumber( 1, 6 ) ]

		SANTA->HOME_PHONE := LTRIM( STR( nAreaCode + nExchange + NewNumber( 1000, 9999 ) ) )
		SANTA->WORK_PHONE := LTRIM( STR( nAreaCode + nExchange + NewNumber( 1000, 9999 ) ) )
		SANTA->CITY       := aCities[ NewNumber( 1, 32 ) ]
		SANTA->STATE      := aStates[ NewNumber( 1, 50 ) ]
		SANTA->COUNTRY    := "USA"
		SANTA->ZIP        := LTRIM( STR( NewNumber( 10000, 99999 ) ) ) + "-" + LTRIM( STR( NewNumber( 1000, 9999 ) ) )
		SANTA->GOOD_BAD   := IIF( NewNumber( 1, 4 ) == 1, FALSE, TRUE )

		IF ( lYield .and. ( ( i % 10 ) == 0 ) )
			// check the message queue
			yield()
		ENDIF

	NEXT

	SANTA->( dbCloseArea() )

RETURN


FUNCTION NewNumber( nLRange, nURange )

#define RND_DIVISOR  10000000
#define RND_FACTOR    3236713

	STATIC	nSeed

	// init seed
	IF ( nSeed == NIL )
		nSeed := SECONDS()
	ENDIF


RETURN( ;
	INT( ;
		( nURange - nLRange + 1 ) * ;
		( ( nSeed := MOD( nSeed * RND_FACTOR + 1, RND_DIVISOR ) ) / RND_DIVISOR ) ;
		) + nLRange ;
	)


FUNCTION Twiddle()

	STATIC nCounter := 0
	LOCAL cChar
	LOCAL nVal

	nVal := ( ++nCounter % 4 )
	DO CASE
	CASE nVal == 0 ; cChar := "|"
	CASE nVal == 1 ; cChar := "/"
	CASE nVal == 2 ; cChar := "-"
	CASE nVal == 3 ; cChar := "\"
	ENDCASE

RETURN( cChar )


