// Program 
// Application  : Event Driven Programming Sample
// Purpose      : Demonstrate a simple dialog box
// File Name    : SANTA.PRG
// Section      :
// Category     :
// Description  : Demonstrate a simple dialog box
// Author       : Erik Wynn
// Copyright    : (c) 1993 by Wynn Systems Development Group, Ltd.
// Date created : 04-22-93              Date updated: 04-22-93
// Time created : 04:16:26pm            Time updated: 04:16:26pm
//

// Function/Procedure Prototype Table  -  Last Update: 04-22-93 @ 04:16:17pm
// 
// Return Value         Function/Arguments
//   
// Void                 PROCEDURE SantaAbort( aWind )
// Void                 PROCEDURE SantaInit( aWind )
// Void                 PROCEDURE SantaProc( aMsg )
// Void                 PROCEDURE SantaSave( aWind )

#include "wind.ch"
#include "msg.ch"
#include "misc.ch"
#include "get.ch"

STATIC cFirstName
STATIC cLastName
STATIC cHomePhone
STATIC cWorkPhone
STATIC cAddress
STATIC cCity
STATIC cState
STATIC cCountry
STATIC cZip
STATIC lGoodBad


PROCEDURE SantaProc( aMsg )

	LOCAL msg   := aMsg[ M_MSG ]
	LOCAL aWind := aMsg[ M_WINDOW ]

	DO CASE
	CASE ( msg == WM_CREATE )
		SantaInit( aWind )

	CASE ( msg == DLG_SAVE )
		SantaSave( aWind )

	CASE ( msg == DLG_ABORT )
		SantaAbort( aWind )

	ENDCASE

RETURN


PROCEDURE SantaInit( aWind )

	LOCAL getList := {}
	LOCAL aDialog := aWind[ W_CARGO ]

	// initialize get values
	cFirstName := SPACE( 10 )
	cLastName  := SPACE( 20 )
	cHomePhone := SPACE( 10 )
	cWorkPhone := SPACE( 10 )
	cAddress   := SPACE( 30 )
	cCity      := SPACE( 20 )
	cState     := SPACE( 20 )
	cCountry   := SPACE( 20 )
	cZip       := SPACE( 10 )
	lGoodBad   := TRUE

	// begin video buffering
	DISPBEGIN()

	// display window to receive SAYs and GETs
	wDisp( aWind )

	// add a few get items to the window
	@  2, 1 SAY "First Name : " GET cFirstName IN WINDOW aWind
	@  3, 1 SAY "Last Name  : " GET cLastName  IN WINDOW aWind
	@  4, 1 SAY "Address    : " GET cAddress   IN WINDOW aWind
	@  5, 1 SAY "City       : " GET cCity      IN WINDOW aWind
	@  6, 1 SAY "State      : " GET cState     IN WINDOW aWind
	@  7, 1 SAY "Country    : " GET cCountry   IN WINDOW aWind
	@  8, 1 SAY "Zip Code   : " GET cZip       IN WINDOW aWind PICTURE "@R 99999-9999"
	@  9, 1 SAY "Home Phone : " GET cHomePhone IN WINDOW aWind PICTURE "@R (999) 999-9999"
	@ 10, 1 SAY "Work Phone : " GET cWorkPhone IN WINDOW aWind PICTURE "@R (999) 999-9999"

	@ 13, 1 SAY "Good / Bad : " GET lGoodBad   IN WINDOW aWind

	// hide the window again
	wHide( aWind )

	// end video buffering
	DISPEND()

	aDialog[ GET_GETLIST ] := getList

RETURN


PROCEDURE SantaSave( aWind )

	LOCAL aDialog := aWind[ W_CARGO ]
	LOCAL wSaved  := MessageNew( "Saved", aWind[ W_T ] + 2, aWind[ W_L ] + 2, aWind[ W_T ] + 7, aWind[ W_L ] + 28, aWind )

	SetFocus( wSaved )
	wDisp( wSaved )
	wSay( wSaved, 2, 1, "Data has been saved!" )
	wSay( wSaved, 4, 1, "Press any key to continue." )

RETURN


PROCEDURE SantaAbort( aWind )

	LOCAL aDialog  := aWind[ W_CARGO ]
	LOCAL wAborted := MessageNew( "Aborted", aWind[ W_T ] + 2, aWind[ W_L ] + 2, aWind[ W_T ] + 7, aWind[ W_L ] + 28, aWind )

	SetFocus( wAborted )
	wDisp( wAborted )
	wSay( wAborted, 2, 1, "Data has been Aborted!" )
	wSay( wAborted, 4, 1, "Press any key to continue." )

RETURN



