#include "inkey.ch"
#include "msg.ch"
#include "wind.ch"
#include "misc.ch"

PROCEDURE TextProc( aMsg )

	LOCAL aWind   := aMsg[ M_WINDOW ]
	LOCAL msg     := aMsg[ M_MSG ]
	LOCAL nParm   := aMsg[ M_PARM ]

	DO CASE
	CASE ( msg == WM_SETFOCUS )
		wGetFocus( aWind )

	CASE ( msg == WM_KILLFOCUS )
		wKillFocus( aWind )

	CASE ( msg == WM_MOVE )
		wMove( aWind, nParm )

	CASE ( msg == WM_HIDE )
		wHide( aWind )

	CASE ( msg == WM_PAINT )
		wDisp( aWind )

	CASE ( msg == WM_DESTROY )
		wKill( aWind )

	CASE ( msg == WM_CHAR )

		DO CASE
		CASE ( nParm == K_ENTER )
			// advance to the next line
			wLineAdvance( aWind )

		CASE ( nParm == K_BS )
			// back up by one, if possible
			IF ! ( ( aWind[ W_CURS_ROW ] == 1 ) .and. ( aWind[ W_CURS_COL ] == 1 ) )
				wCsrRewind( aWind )
				wPrintChar( aWind, " " )
				wPrintChar( aWind, "" )
			ENDIF

		CASE ( nParm > 31 )
			// printable character -- print it
			wPrintText( aWind, nParm )

		OTHERWISE
			TONE( 400, 2 )

		ENDCASE

	ENDCASE

RETURN

