//  Clipper Header Ŀ
//  File Name    : WIND.CH                                                  
//  Description  : Header file for window manifest constants.               
//  Author       : Erik Wynn                                                
//  Date created : 02-02-93                                                 
//  Time created : 11:07:53am                                               
//  Copyright    : 1993 by Wynn Systems Development Group, Ltd.             
// 

#define W_TITLE      1                           // window title
#define W_T          2                           // top
#define W_L          3                           // left
#define W_B          4                           // bottom
#define W_R          5                           // right
#define W_CURS_ROW   6                           // cursor row
#define W_CURS_COL   7                           // cursor column
#define W_CURS_STAT  8                           // cursor status
#define W_PROC       9                           // window procedure
#define W_TIMER     10                           // time interval to receive WM_TIMER messages
#define W_LASTTIME  11                           // last time window received WM_TIMER message
#define W_PREVSCR   12                           // previous screen
#define W_CURRSCR   13                           // contents of window
#define W_PREV      14                           // previous window in list
#define W_NEXT      15                           // next window in list
#define W_HASFOCUS  16                           // true if window has focus
#define W_AREA_CLR  17                           // color for window area
#define W_TTL_CLR   18                           // color for window title
#define W_FOCUS_CLR 19                           // color for title when in focus
#define W_TEXT_CLR  20                           // color for window text
#define W_GET_CLR   21                           // color for gets in window

#define W_T_LIMIT   22                           // top limit
#define W_L_LIMIT   23                           // left limit
#define W_B_LIMIT   24                           // bottom limit
#define W_R_LIMIT   25                           // right limit

#define W_HIDDEN    26                           // true if window is hidden

#define W_CARGO     27                           // any junk

#define W_ASIZE     27                           // size of window array

// default values
#define CLR_WIND  "N/W"
#define CLR_TITLE "N/BG"
#define CLR_FOCUS "N/GR*"
#define CLR_TEXT  "B/W"
#define CLR_GET   "W/B, B/BG,,, GR+/B"

